//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39A3E1C30247.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39A3E1C30247.cm

//## begin module%39A3E1C30247.cp preserve=no
//## end module%39A3E1C30247.cp

//## Module: OGIP-92aIO%39A3E1C30247; Package specification
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/DataFactory/OGIP-92aIO.h

#ifndef OGIP_92AIO_H
#define OGIP_92AIO_H 1

//## begin module%39A3E1C30247.additionalIncludes preserve=no
//## end module%39A3E1C30247.additionalIncludes

//## begin module%39A3E1C30247.includes preserve=yes
#include <XSModel/DataFactory/XspecDataIO.h>
#include <XSModel/Data/DataUtility.h>
//## end module%39A3E1C30247.includes

//## begin module%39A3E1C30247.declarations preserve=no
//## end module%39A3E1C30247.declarations

//## begin module%39A3E1C30247.additionalDeclarations preserve=yes
namespace CCfits
{
  class FITS;
  class ExtHDU;
}
//## end module%39A3E1C30247.additionalDeclarations


//## begin OGIP_92aIO%39A3E30701CC.preface preserve=yes
//## end OGIP_92aIO%39A3E30701CC.preface

//## Class: OGIP-92aIO%39A3E30701CC
//	See XspecDataIO for details.
//## Category: XSModel::DataFactory%399415D40147
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3AAD01B201CA;CCfits::ExtHDU { -> F}

class OGIP_92aIO : public XspecDataIO  //## Inherits: <unnamed>%3AACF98E00CE
{
  //## begin OGIP_92aIO%39A3E30701CC.initialDeclarations preserve=yes
  //## end OGIP_92aIO%39A3E30701CC.initialDeclarations

  public:
    //## Class: IncorrectDataType%3F73491A00AF
    //## Category: XSModel::DataFactory%399415D40147
    //## Subsystem: XSModel::DataFactory%3994285E0087
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class IncorrectDataType : public YellowAlert  //## Inherits: <unnamed>%3F7349720357
    {
      public:
        //## Constructors (specified)
          //## Operation: IncorrectDataType%3F7349340326
          IncorrectDataType (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: OptCols%3F744BE70393
    //## Category: XSModel::DataFactory%399415D40147
    //## Subsystem: XSModel::DataFactory%3994285E0087
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {COUNTS_COL,STATERR_COL,QUAL_COL,GROUP_COL,ASCALE_COL,BSCALE_COL,NOPTCOLS} OptCols;

    //## Class: StorageType%402406E7019F
    //## Category: XSModel::DataFactory%399415D40147
    //## Subsystem: XSModel::DataFactory%3994285E0087
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {NO_STORE, KEYSTORE, COLSTORE} StorageType;


    //## Other Operations (specified)
      //## Operation: read%39A3E3E60027
      virtual size_t read (const string& fileName, bool readFlag = true);

      //## Operation: write%39A3E3EB02F8
      virtual void write (const string& fileName);

      //## Operation: fileFormat%39AD44730366
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: dataSource%3AC39C880130
      const CCfits::FITS* dataSource (size_t index = 0) const;

      //## Operation: setDataSource%3AC39CCC009C
      void setDataSource (CCfits::FITS* fitsObject, size_t index = 0);

      //## Operation: dataSource%3AC3A9370394
      CCfits::FITS* dataSource (size_t index = 0);

      //## Operation: getKeyIntValue%3EA054B9011F
      static int getKeyIntValue (CCfits::FITS* fitsFile, const string& keyWord);

      //## Operation: openFitsExtension%41C1A5C8003A
      //	If fileName does not contain extended syntax or curly
      //	brackets, return the first extension that matches the
      //	keyword criteria given by the type, throw if none.  If
      //	using extended syntax OR curly bracket extver specifier,
      //	return the specific HDU only if it also has the proper
      //	keywords, otherwise throw. This will throw  if extended
      //	syntax and curly brackets are used together.  NOTE: this
      //	function always interprets curly brackets to mean extver
      //	and NOT row numbers.  Row number specifier should not be
      //	part of the fileName sent to this function.
      static std::auto_ptr<CCfits::FITS> openFitsExtension (const string& fileName, XspecDataIO::DataType type);

      //## Operation: qualityStorage%4373816301DB
      OGIP_92aIO::StorageType  qualityStorage () const;

      //## Operation: groupingStorage%437381E20124
      OGIP_92aIO::StorageType groupingStorage () const;

      //## Operation: getChanInfoFromResponse%460BD7AE0351
      static std::pair<int,int> getChanInfoFromResponse (const string& fileName);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: extVers%48A498300276
      int extVers () const;
      void extVers (int value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::DataFactory::<unnamed>%3AAD0ADD007D
      //## Role: OGIP_92aIO::AuxResponseKeys%3AAD0ADE0259
      static const std::vector<std::string>& AuxResponseKeys ();
      static void AuxResponseKeys (const std::vector<std::string>& value);

  public:
    // Additional Public Declarations
      //## begin OGIP_92aIO%39A3E30701CC.public preserve=yes
      //## end OGIP_92aIO%39A3E30701CC.public

  protected:
    //## Constructors (generated)
      OGIP_92aIO();

      OGIP_92aIO(const OGIP_92aIO &right);

    //## Destructor (generated)
      virtual ~OGIP_92aIO();


    //## Other Operations (specified)
      //## Operation: channelBounds%39FDAD1D037A
      virtual void channelBounds (int& startChannel, int& endChannel, size_t row = 0) const;

      //## Operation: verifyQualGroup%3A01A8FF0321
      int verifyQualGroup (const int startChan, const int endChan, IntegerArray& qual, IntegerArray& group, size_t row = 0);

      //## Operation: isCounts%3A2D2E470007
      //	OGIP files have PHA array stored as counts or rate.
      //	This function returns true if it's counts.
      bool isCounts () const;

      //## Operation: specNum%39E4BF9801BE
      bool specNum (CCfits::ExtHDU& hdu) const;

      //## Operation: closeFile%3A39418603DC
      void closeFile (size_t  index = 0);

      //## Operation: swap%3A95795F00F4
      virtual void swap (OGIP_92aIO& right);

      //## Operation: makeType1Table%3EF7070400BE
      CCfits::Table* makeType1Table (string& hduName, size_t nChans, const BoolArray& optCols);

      //## Operation: makeType2Table%3EF707100386
      CCfits::Table* makeType2Table (string& hduName, size_t nSpec, size_t nChans, const BoolArray& optCols);

      //## Operation: getNetType%3FD88D060240
      void getNetType ();

      //## Operation: isNet%3FD89015032A
      //	Type of file can be TOTAL, NET, BKG. This returns true
      //	if it's NET.
      bool isNet () const;

      //## Operation: getDataType%3FD890D8026B
      void getDataType ();

      //## Operation: getQualGroupStorage%4024089701EC
      void getQualGroupStorage (const string& keyword);

      //## Operation: channelLimits%41CB0175033E
      void channelLimits (const size_t lowDefault, size_t& legalStart, size_t& legalEnd) const;

      //## Operation: readChannelBounds%41DECC7201E3
      static void readChannelBounds (CCfits::ExtHDU& ext, int& startChannel, int& endChannel, const size_t row);

      //## Operation: readChannelLimits%41DF059F0339
      static void readChannelLimits (CCfits::ExtHDU& ext, const size_t lowDefault, size_t& legalStart, size_t& legalEnd);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: HDUCLASS%39CB9EC50196
      static const string& HDUCLASS ();

      //## Attribute: extensionName%39E4B6AD037C
      //	Store the FITS header name. Set by fileFormat: avoids the
      //	need to open the file at the read stage.
      //
      //	NOTE: still need to find HDU for files which contain
      //	more than one extension of interest (e.g. responses
      //	which need MATRIX or its variants and EBOUNDS).
      const string& extensionName () const;
      void setExtensionName (const string& value);

      //## Attribute: HDUVERS%39CB9F17026A
      static const string& HDUVERS ();

      //## Attribute: PHAVERSN%39CB9FA201BB
      static const string& PHAVERSN ();

      //## Attribute: VERSKEY%39CBA074017E
      static const string& VERSKEY ();

      //## Attribute: SPECTYPE%39CBA1EB012B
      static const string& SPECTYPE ();

      //## Attribute: HDUCLAS1%39CBA1FB03E7
      static const string& HDUCLAS1 ();

      //## Attribute: RMFVERSN%39D0D4580244
      static const string& RMFVERSN ();

      //## Attribute: ARFVERSN%39D0D48302BB
      static const string& ARFVERSN ();

      //## Attribute: OGIPVERS%39D0D4A000A6
      static const string& OGIPVERS ();

      //## Attribute: RESPTYPE%39D0D512011E
      static const string& RESPTYPE ();

      //## Attribute: SPECRESPTYPE%39D0D66500E4
      static const string& SPECRESPTYPE ();

      //## Attribute: HDUCLAS2%39D0D68E030B
      static const string& HDUCLAS2 ();

      //## Attribute: OGIPTYPE%39D0D98002E2
      static const string& OGIPTYPE ();

      //## Attribute: NUMKEY%39D0DF5D0397
      static const string& NUMKEY ();

      //## Attribute: CHANNEL%39DCC2BC017B
      static const string& CHANNEL ();

      //## Attribute: TELESCOPE%39DCC3000342
      static const string& TELESCOPE ();

      //## Attribute: INSTRUMENT%39DCC31802A9
      static const string& INSTRUMENT ();

      //## Attribute: BACKFILE%39DCC35B0243
      static const string& BACKFILE ();

      //## Attribute: RESPFILE%39DCC37D0123
      static const string& RESPFILE ();

      //## Attribute: CORRFILE%39DCC380030B
      static const string& CORRFILE ();

      //## Attribute: ANCRFILE%39DCC3840082
      static const string& ANCRFILE ();

      //## Attribute: AREASCALE%39DCC3FA0279
      static const string& AREASCALE ();

      //## Attribute: BACKSCALE%39DCC3FF027D
      static const string& BACKSCALE ();

      //## Attribute: CORRSCALE%39DCC40302B7
      static const string& CORRSCALE ();

      //## Attribute: EXPOSURE%39DCC4070133
      static const string& EXPOSURE ();

      //## Attribute: FILTER%39DCC40B015B
      static const string& FILTER ();

      //## Attribute: GROUPING%39DCC4EB0196
      static const string& GROUPING ();

      //## Attribute: QUALITY%39DCC4EF003B
      static const string& QUALITY ();

      //## Attribute: MAXFILTER%39DCCF3F0191
      static const size_t& MAXFILTER ();

      //## Attribute: CHANNELTYPE%39DCD8290218
      static const string& CHANNELTYPE ();

      //## Attribute: COUNTS%39DCD8E7023A
      static const string& COUNTS ();

      //## Attribute: RATE%39DCDA780352
      static const string& RATE ();

      //## Attribute: SYSTEMATIC%39E362940011
      static const string& SYSTEMATIC ();

      //## Attribute: STATISTICAL%39E3629A0358
      static const string& STATISTICAL ();

      //## Attribute: POISSERR%39FDEA390117
      static const string& POISSERR ();

      //## Attribute: MINENERGY%3A002E4101C3
      static const string& MINENERGY ();

      //## Attribute: MAXENERGY%3A002E62003F
      static const string& MAXENERGY ();

      //## Attribute: ENERGYLO%3A002E7D0352
      static const string& ENERGYLO ();

      //## Attribute: ENERGYHI%3A002EA500AB
      static const string& ENERGYHI ();

      //## Attribute: NGROUP%3A002EC000DD
      static const string& NGROUP ();

      //## Attribute: NCHANNEL%3A002EE103CD
      static const string& NCHANNEL ();

      //## Attribute: FCHANNEL%3A002EFE0085
      static const string& FCHANNEL ();

      //## Attribute: MATRIX%3A002F1B0113
      static const string& MATRIX ();

      //## Attribute: DETNAM%3A003AAA03B0
      static const string& DETNAM ();

      //## Attribute: DETCHANS%3A003ACE0233
      static const string& DETCHANS ();

      //## Attribute: RSPVERSN%3A003AD10011
      static const string& RSPVERSN ();

      //## Attribute: EBOUNDS%3A40D2AE01E3
      static const string& EBOUNDS ();

      //## Attribute: RSPMATRIXTYPE%3A6DF2D203CA
      static const string& RSPMATRIXTYPE ();

      //## Attribute: HDUCLAS3%3FD8899E036B
      static const string& HDUCLAS3 ();

      //## Attribute: GSLOP_MIN%4A3A58C6019E
      static const string& GSLOP_MIN ();

      //## Attribute: GSLOP_MAX%4A3A58C9013C
      static const string& GSLOP_MAX ();

      //## Attribute: GOFFS_MIN%4A3A58CC002B
      static const string& GOFFS_MIN ();

      //## Attribute: GOFFS_MAX%4A3A58CE030F
      static const string& GOFFS_MAX ();

      //## Attribute: net%3FD8904701AA
      void net (bool value);

      //## Attribute: netIsSet%3FD8983A00D9
      bool netIsSet () const;
      void netIsSet (bool value);

      //## Attribute: qualityStorage%402407EA011B
      void qualityStorage (OGIP_92aIO::StorageType value);

      //## Attribute: groupingStorage%4024082E019E
      void groupingStorage (OGIP_92aIO::StorageType value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::DataFactory::<unnamed>%39E5D8CA037A
      //## Role: OGIP_92aIO::ResponseKeys%39E5D8CC03D5
      static const std::vector<std::string>& ResponseKeys ();

      //## Association: XSModel::DataFactory::<unnamed>%3AAD00DB01E4
      //## Role: OGIP_92aIO::dataSource%3AAD00DC0080
      const std::vector<CCfits::FITS*>& getDataSource () const;
      void setDataSource (const std::vector<CCfits::FITS*>& value);

      //## Association: XSModel::DataFactory::<unnamed>%3EF372DF036D
      //## Role: OGIP_92aIO::typeIColNames%3EF372E300F6
      static const std::vector<std::string>& typeIColNames ();

      //## Association: XSModel::DataFactory::<unnamed>%3EF374B3018E
      //## Role: OGIP_92aIO::typeIColForms%3EF374B50243
      static const std::vector<std::string>& typeIColForms ();

      //## Association: XSModel::DataFactory::<unnamed>%3EF3754D03BA
      //## Role: OGIP_92aIO::typeIColUnits%3EF3754F01A2
      static const std::vector<std::string>& typeIColUnits ();

    // Additional Protected Declarations
      //## begin OGIP_92aIO%39A3E30701CC.protected preserve=yes
      //## end OGIP_92aIO%39A3E30701CC.protected

  private:
    //## Assignment Operation (generated)
      OGIP_92aIO & operator=(const OGIP_92aIO &right);


    //## Other Operations (specified)
      //## Operation: callFITSctor%4A55F94002FB
      //	A private utility function used by openFitsExtension,
      //	this calls the appropriate FITS constructor based on
      //	whether there's extended syntax in the filename, and
      //	also verifies the search key values.  This may throw Fits
      //	Exceptions.  If using extended syntax and the indicated
      //	HDU is found but doesn't have the proper search keys, a
      //	null pointer is returned.
      //
      //	When using extended syntax, extVers will be modified to
      //	match the value in the HDU given by the extended name.
      //	For regular filenames, extVers is read-only and will be
      //	used along with the searchKeys to pinpoint the specific
      //	HDU.
      static CCfits::FITS* callFITSctor (const string& filename, const StringArray& searchKeys, const StringArray& searchVals, const bool isExtended, int& extVers);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::DataFactory::<unnamed>%39DCD1F90022
      //## Role: OGIP_92aIO::SpectrumKeys%39DCD1FA01FE
      static std::vector<std::string>& SpectrumKeys ();
      static void SpectrumKeys (const std::vector<std::string>& value);

    // Additional Private Declarations
      //## begin OGIP_92aIO%39A3E30701CC.private preserve=yes
      //## end OGIP_92aIO%39A3E30701CC.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin OGIP_92aIO::HDUCLASS%39CB9EC50196.attr preserve=no  protected: static string {VC} "HDUCLASS"
      static const string s_HDUCLASS;
      //## end OGIP_92aIO::HDUCLASS%39CB9EC50196.attr

      //## begin OGIP_92aIO::extensionName%39E4B6AD037C.attr preserve=no  protected: string {U} ""
      string m_extensionName;
      //## end OGIP_92aIO::extensionName%39E4B6AD037C.attr

      //## begin OGIP_92aIO::HDUVERS%39CB9F17026A.attr preserve=no  protected: static string {UC} "HDUVERS"
      static const string s_HDUVERS;
      //## end OGIP_92aIO::HDUVERS%39CB9F17026A.attr

      //## begin OGIP_92aIO::PHAVERSN%39CB9FA201BB.attr preserve=no  protected: static string {VC} "PHAVERSN"
      static const string s_PHAVERSN;
      //## end OGIP_92aIO::PHAVERSN%39CB9FA201BB.attr

      //## begin OGIP_92aIO::VERSKEY%39CBA074017E.attr preserve=no  protected: static string {UC} "1."
      static const string s_VERSKEY;
      //## end OGIP_92aIO::VERSKEY%39CBA074017E.attr

      //## begin OGIP_92aIO::SPECTYPE%39CBA1EB012B.attr preserve=no  protected: static string {UC} "SPECTRUM"
      static const string s_SPECTYPE;
      //## end OGIP_92aIO::SPECTYPE%39CBA1EB012B.attr

      //## begin OGIP_92aIO::HDUCLAS1%39CBA1FB03E7.attr preserve=no  protected: static string {UC} "HDUCLAS1"
      static const string s_HDUCLAS1;
      //## end OGIP_92aIO::HDUCLAS1%39CBA1FB03E7.attr

      //## begin OGIP_92aIO::RMFVERSN%39D0D4580244.attr preserve=no  protected: static string {UC} "RMFVERSN"
      static const string s_RMFVERSN;
      //## end OGIP_92aIO::RMFVERSN%39D0D4580244.attr

      //## begin OGIP_92aIO::ARFVERSN%39D0D48302BB.attr preserve=no  protected: static string {UC} "ARFVERSN"
      static const string s_ARFVERSN;
      //## end OGIP_92aIO::ARFVERSN%39D0D48302BB.attr

      //## begin OGIP_92aIO::OGIPVERS%39D0D4A000A6.attr preserve=no  protected: static string {VC} "1992a"
      static const string s_OGIPVERS;
      //## end OGIP_92aIO::OGIPVERS%39D0D4A000A6.attr

      //## begin OGIP_92aIO::RESPTYPE%39D0D512011E.attr preserve=no  protected: static string {UC} "RESPONSE"
      static const string s_RESPTYPE;
      //## end OGIP_92aIO::RESPTYPE%39D0D512011E.attr

      //## begin OGIP_92aIO::SPECRESPTYPE%39D0D66500E4.attr preserve=no  protected: static string {UC} "SPECRESP"
      static const string s_SPECRESPTYPE;
      //## end OGIP_92aIO::SPECRESPTYPE%39D0D66500E4.attr

      //## begin OGIP_92aIO::HDUCLAS2%39D0D68E030B.attr preserve=no  protected: static string {UC} "HDUCLAS2"
      static const string s_HDUCLAS2;
      //## end OGIP_92aIO::HDUCLAS2%39D0D68E030B.attr

      //## begin OGIP_92aIO::OGIPTYPE%39D0D98002E2.attr preserve=no  protected: static string {UC} "OGIP"
      static const string s_OGIPTYPE;
      //## end OGIP_92aIO::OGIPTYPE%39D0D98002E2.attr

      //## begin OGIP_92aIO::NUMKEY%39D0DF5D0397.attr preserve=no  protected: static string {UC} "SPEC_NUM"
      static const string s_NUMKEY;
      //## end OGIP_92aIO::NUMKEY%39D0DF5D0397.attr

      //## begin OGIP_92aIO::CHANNEL%39DCC2BC017B.attr preserve=no  protected: static string {UC} "CHANNEL"
      static const string s_CHANNEL;
      //## end OGIP_92aIO::CHANNEL%39DCC2BC017B.attr

      //## begin OGIP_92aIO::TELESCOPE%39DCC3000342.attr preserve=no  protected: static string {UC} "TELESCOP"
      static const string s_TELESCOPE;
      //## end OGIP_92aIO::TELESCOPE%39DCC3000342.attr

      //## begin OGIP_92aIO::INSTRUMENT%39DCC31802A9.attr preserve=no  protected: static string {UC} "INSTRUME"
      static const string s_INSTRUMENT;
      //## end OGIP_92aIO::INSTRUMENT%39DCC31802A9.attr

      //## begin OGIP_92aIO::BACKFILE%39DCC35B0243.attr preserve=no  protected: static string {UC} "BACKFILE"
      static const string s_BACKFILE;
      //## end OGIP_92aIO::BACKFILE%39DCC35B0243.attr

      //## begin OGIP_92aIO::RESPFILE%39DCC37D0123.attr preserve=no  protected: static string {UC} "RESPFILE"
      static const string s_RESPFILE;
      //## end OGIP_92aIO::RESPFILE%39DCC37D0123.attr

      //## begin OGIP_92aIO::CORRFILE%39DCC380030B.attr preserve=no  protected: static string {UC} "CORRFILE"
      static const string s_CORRFILE;
      //## end OGIP_92aIO::CORRFILE%39DCC380030B.attr

      //## begin OGIP_92aIO::ANCRFILE%39DCC3840082.attr preserve=no  protected: static string {UC} "ANCRFILE"
      static const string s_ANCRFILE;
      //## end OGIP_92aIO::ANCRFILE%39DCC3840082.attr

      //## begin OGIP_92aIO::AREASCALE%39DCC3FA0279.attr preserve=no  protected: static string {UC} "AREASCAL"
      static const string s_AREASCALE;
      //## end OGIP_92aIO::AREASCALE%39DCC3FA0279.attr

      //## begin OGIP_92aIO::BACKSCALE%39DCC3FF027D.attr preserve=no  protected: static string {UC} "BACKSCAL"
      static const string s_BACKSCALE;
      //## end OGIP_92aIO::BACKSCALE%39DCC3FF027D.attr

      //## begin OGIP_92aIO::CORRSCALE%39DCC40302B7.attr preserve=no  protected: static string {UC} "CORRSCAL"
      static const string s_CORRSCALE;
      //## end OGIP_92aIO::CORRSCALE%39DCC40302B7.attr

      //## begin OGIP_92aIO::EXPOSURE%39DCC4070133.attr preserve=no  protected: static string {UC} "EXPOSURE"
      static const string s_EXPOSURE;
      //## end OGIP_92aIO::EXPOSURE%39DCC4070133.attr

      //## begin OGIP_92aIO::FILTER%39DCC40B015B.attr preserve=no  protected: static string {UC} "XFLT"
      static const string s_FILTER;
      //## end OGIP_92aIO::FILTER%39DCC40B015B.attr

      //## begin OGIP_92aIO::GROUPING%39DCC4EB0196.attr preserve=no  protected: static string {UC} "GROUPING"
      static const string s_GROUPING;
      //## end OGIP_92aIO::GROUPING%39DCC4EB0196.attr

      //## begin OGIP_92aIO::QUALITY%39DCC4EF003B.attr preserve=no  protected: static string {UC} "QUALITY"
      static const string s_QUALITY;
      //## end OGIP_92aIO::QUALITY%39DCC4EF003B.attr

      //## begin OGIP_92aIO::MAXFILTER%39DCCF3F0191.attr preserve=no  protected: static size_t {VC} 10
      static const size_t s_MAXFILTER;
      //## end OGIP_92aIO::MAXFILTER%39DCCF3F0191.attr

      //## begin OGIP_92aIO::CHANNELTYPE%39DCD8290218.attr preserve=no  protected: static string {UC} "CHANTYPE"
      static const string s_CHANNELTYPE;
      //## end OGIP_92aIO::CHANNELTYPE%39DCD8290218.attr

      //## begin OGIP_92aIO::COUNTS%39DCD8E7023A.attr preserve=no  protected: static string {UC} "COUNTS"
      static const string s_COUNTS;
      //## end OGIP_92aIO::COUNTS%39DCD8E7023A.attr

      //## begin OGIP_92aIO::RATE%39DCDA780352.attr preserve=no  protected: static string {UC} "RATE"
      static const string s_RATE;
      //## end OGIP_92aIO::RATE%39DCDA780352.attr

      //## begin OGIP_92aIO::SYSTEMATIC%39E362940011.attr preserve=no  protected: static string {UC} "SYS_ERR"
      static const string s_SYSTEMATIC;
      //## end OGIP_92aIO::SYSTEMATIC%39E362940011.attr

      //## begin OGIP_92aIO::STATISTICAL%39E3629A0358.attr preserve=no  protected: static string {UC} "STAT_ERR"
      static const string s_STATISTICAL;
      //## end OGIP_92aIO::STATISTICAL%39E3629A0358.attr

      //## begin OGIP_92aIO::POISSERR%39FDEA390117.attr preserve=no  protected: static string {UC} "POISSERR"
      static const string s_POISSERR;
      //## end OGIP_92aIO::POISSERR%39FDEA390117.attr

      //## begin OGIP_92aIO::MINENERGY%3A002E4101C3.attr preserve=no  protected: static string {UC} "E_MIN"
      static const string s_MINENERGY;
      //## end OGIP_92aIO::MINENERGY%3A002E4101C3.attr

      //## begin OGIP_92aIO::MAXENERGY%3A002E62003F.attr preserve=no  protected: static string {UC} "E_MAX"
      static const string s_MAXENERGY;
      //## end OGIP_92aIO::MAXENERGY%3A002E62003F.attr

      //## begin OGIP_92aIO::ENERGYLO%3A002E7D0352.attr preserve=no  protected: static string {UC} "ENERG_LO"
      static const string s_ENERGYLO;
      //## end OGIP_92aIO::ENERGYLO%3A002E7D0352.attr

      //## begin OGIP_92aIO::ENERGYHI%3A002EA500AB.attr preserve=no  protected: static string {UC} "ENERG_HI"
      static const string s_ENERGYHI;
      //## end OGIP_92aIO::ENERGYHI%3A002EA500AB.attr

      //## begin OGIP_92aIO::NGROUP%3A002EC000DD.attr preserve=no  protected: static string {UC} "N_GRP"
      static const string s_NGROUP;
      //## end OGIP_92aIO::NGROUP%3A002EC000DD.attr

      //## begin OGIP_92aIO::NCHANNEL%3A002EE103CD.attr preserve=no  protected: static string {UC} "N_CHAN"
      static const string s_NCHANNEL;
      //## end OGIP_92aIO::NCHANNEL%3A002EE103CD.attr

      //## begin OGIP_92aIO::FCHANNEL%3A002EFE0085.attr preserve=no  protected: static string {UC} "F_CHAN"
      static const string s_FCHANNEL;
      //## end OGIP_92aIO::FCHANNEL%3A002EFE0085.attr

      //## begin OGIP_92aIO::MATRIX%3A002F1B0113.attr preserve=no  protected: static string {UC} "MATRIX"
      static const string s_MATRIX;
      //## end OGIP_92aIO::MATRIX%3A002F1B0113.attr

      //## begin OGIP_92aIO::DETNAM%3A003AAA03B0.attr preserve=no  protected: static string {UC} "DETNAM"
      static const string s_DETNAM;
      //## end OGIP_92aIO::DETNAM%3A003AAA03B0.attr

      //## begin OGIP_92aIO::DETCHANS%3A003ACE0233.attr preserve=no  protected: static string {UC} "DETCHANS"
      static const string s_DETCHANS;
      //## end OGIP_92aIO::DETCHANS%3A003ACE0233.attr

      //## begin OGIP_92aIO::RSPVERSN%3A003AD10011.attr preserve=no  protected: static string {UC} "RSPVERSN"
      static const string s_RSPVERSN;
      //## end OGIP_92aIO::RSPVERSN%3A003AD10011.attr

      //## begin OGIP_92aIO::EBOUNDS%3A40D2AE01E3.attr preserve=no  protected: static string {UC} "EBOUNDS"
      static const string s_EBOUNDS;
      //## end OGIP_92aIO::EBOUNDS%3A40D2AE01E3.attr

      //## begin OGIP_92aIO::RSPMATRIXTYPE%3A6DF2D203CA.attr preserve=no  protected: static string {UC} "RSP_MATRIX"
      static const string s_RSPMATRIXTYPE;
      //## end OGIP_92aIO::RSPMATRIXTYPE%3A6DF2D203CA.attr

      //## begin OGIP_92aIO::HDUCLAS3%3FD8899E036B.attr preserve=no  protected: static string {UC} "HDUCLAS3"
      static const string s_HDUCLAS3;
      //## end OGIP_92aIO::HDUCLAS3%3FD8899E036B.attr

      //## begin OGIP_92aIO::GSLOP_MIN%4A3A58C6019E.attr preserve=no  protected: static string {UC} string("GSLOP_MIN")
      static const string s_GSLOP_MIN;
      //## end OGIP_92aIO::GSLOP_MIN%4A3A58C6019E.attr

      //## begin OGIP_92aIO::GSLOP_MAX%4A3A58C9013C.attr preserve=no  protected: static string {UC} string("GSLOP_MAX")
      static const string s_GSLOP_MAX;
      //## end OGIP_92aIO::GSLOP_MAX%4A3A58C9013C.attr

      //## begin OGIP_92aIO::GOFFS_MIN%4A3A58CC002B.attr preserve=no  protected: static string {UC} string("GOFFS_MIN")
      static const string s_GOFFS_MIN;
      //## end OGIP_92aIO::GOFFS_MIN%4A3A58CC002B.attr

      //## begin OGIP_92aIO::GOFFS_MAX%4A3A58CE030F.attr preserve=no  protected: static string {UC} string("GOFFS_MAX")
      static const string s_GOFFS_MAX;
      //## end OGIP_92aIO::GOFFS_MAX%4A3A58CE030F.attr

      //## begin OGIP_92aIO::net%3FD8904701AA.attr preserve=no  protected: bool {U} 
      bool m_net;
      //## end OGIP_92aIO::net%3FD8904701AA.attr

      //## Attribute: counts%3FD890F8035F
      //## begin OGIP_92aIO::counts%3FD890F8035F.attr preserve=no  private: bool {U} 
      bool m_counts;
      //## end OGIP_92aIO::counts%3FD890F8035F.attr

      //## begin OGIP_92aIO::netIsSet%3FD8983A00D9.attr preserve=no  protected: bool {U} 
      bool m_netIsSet;
      //## end OGIP_92aIO::netIsSet%3FD8983A00D9.attr

      //## begin OGIP_92aIO::qualityStorage%402407EA011B.attr preserve=no  protected: OGIP_92aIO::StorageType {U} 
      OGIP_92aIO::StorageType m_qualityStorage;
      //## end OGIP_92aIO::qualityStorage%402407EA011B.attr

      //## begin OGIP_92aIO::groupingStorage%4024082E019E.attr preserve=no  protected: OGIP_92aIO::StorageType {U} 
      OGIP_92aIO::StorageType m_groupingStorage;
      //## end OGIP_92aIO::groupingStorage%4024082E019E.attr

      //## begin OGIP_92aIO::extVers%48A498300276.attr preserve=no  public: int {U} 
      int m_extVers;
      //## end OGIP_92aIO::extVers%48A498300276.attr

    // Data Members for Associations

      //## Association: XSModel::DataFactory::<unnamed>%39DCD1F90022
      //## begin OGIP_92aIO::SpectrumKeys%39DCD1FA01FE.role preserve=no  private: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_SpectrumKeys;
      //## end OGIP_92aIO::SpectrumKeys%39DCD1FA01FE.role

      //## Association: XSModel::DataFactory::<unnamed>%39E5D8CA037A
      //## begin OGIP_92aIO::ResponseKeys%39E5D8CC03D5.role preserve=no  protected: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_ResponseKeys;
      //## end OGIP_92aIO::ResponseKeys%39E5D8CC03D5.role

      //## Association: XSModel::DataFactory::<unnamed>%3AAD00DB01E4
      //## begin OGIP_92aIO::dataSource%3AAD00DC0080.role preserve=no  protected: CCfits::FITS { -> 1..nRFHgN}
      std::vector<CCfits::FITS*> m_dataSource;
      //## end OGIP_92aIO::dataSource%3AAD00DC0080.role

      //## Association: XSModel::DataFactory::<unnamed>%3AAD0ADD007D
      //## begin OGIP_92aIO::AuxResponseKeys%3AAD0ADE0259.role preserve=no  public: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_AuxResponseKeys;
      //## end OGIP_92aIO::AuxResponseKeys%3AAD0ADE0259.role

      //## Association: XSModel::DataFactory::<unnamed>%3EF372DF036D
      //## begin OGIP_92aIO::typeIColNames%3EF372E300F6.role preserve=no  protected: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_typeIColNames;
      //## end OGIP_92aIO::typeIColNames%3EF372E300F6.role

      //## Association: XSModel::DataFactory::<unnamed>%3EF374B3018E
      //## begin OGIP_92aIO::typeIColForms%3EF374B50243.role preserve=no  protected: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_typeIColForms;
      //## end OGIP_92aIO::typeIColForms%3EF374B50243.role

      //## Association: XSModel::DataFactory::<unnamed>%3EF3754D03BA
      //## begin OGIP_92aIO::typeIColUnits%3EF3754F01A2.role preserve=no  protected: static std::string { -> 1..nVHgN}
      static std::vector<std::string> s_typeIColUnits;
      //## end OGIP_92aIO::typeIColUnits%3EF3754F01A2.role

    // Additional Implementation Declarations
      //## begin OGIP_92aIO%39A3E30701CC.implementation preserve=yes
      //## end OGIP_92aIO%39A3E30701CC.implementation

  //## begin OGIP_92aIO%39A3E30701CC.friends preserve=no
    friend class DataUtility;
  //## end OGIP_92aIO%39A3E30701CC.friends
};

//## begin OGIP_92aIO%39A3E30701CC.postscript preserve=yes
//## end OGIP_92aIO%39A3E30701CC.postscript

// Class OGIP_92aIO::IncorrectDataType 

// Class OGIP_92aIO 


//## Other Operations (inline)
inline OGIP_92aIO::StorageType  OGIP_92aIO::qualityStorage () const
{
  //## begin OGIP_92aIO::qualityStorage%4373816301DB.body preserve=yes
  return m_qualityStorage;
  //## end OGIP_92aIO::qualityStorage%4373816301DB.body
}

inline OGIP_92aIO::StorageType OGIP_92aIO::groupingStorage () const
{
  //## begin OGIP_92aIO::groupingStorage%437381E20124.body preserve=yes
  return m_groupingStorage;
  //## end OGIP_92aIO::groupingStorage%437381E20124.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const string& OGIP_92aIO::HDUCLASS ()
{
  //## begin OGIP_92aIO::HDUCLASS%39CB9EC50196.get preserve=no
  return s_HDUCLASS;
  //## end OGIP_92aIO::HDUCLASS%39CB9EC50196.get
}

inline const string& OGIP_92aIO::extensionName () const
{
  //## begin OGIP_92aIO::extensionName%39E4B6AD037C.get preserve=no
  return m_extensionName;
  //## end OGIP_92aIO::extensionName%39E4B6AD037C.get
}

inline void OGIP_92aIO::setExtensionName (const string& value)
{
  //## begin OGIP_92aIO::setExtensionName%39E4B6AD037C.set preserve=no
  m_extensionName = value;
  //## end OGIP_92aIO::setExtensionName%39E4B6AD037C.set
}

inline const string& OGIP_92aIO::HDUVERS ()
{
  //## begin OGIP_92aIO::HDUVERS%39CB9F17026A.get preserve=no
  return s_HDUVERS;
  //## end OGIP_92aIO::HDUVERS%39CB9F17026A.get
}

inline const string& OGIP_92aIO::PHAVERSN ()
{
  //## begin OGIP_92aIO::PHAVERSN%39CB9FA201BB.get preserve=no
  return s_PHAVERSN;
  //## end OGIP_92aIO::PHAVERSN%39CB9FA201BB.get
}

inline const string& OGIP_92aIO::VERSKEY ()
{
  //## begin OGIP_92aIO::VERSKEY%39CBA074017E.get preserve=no
  return s_VERSKEY;
  //## end OGIP_92aIO::VERSKEY%39CBA074017E.get
}

inline const string& OGIP_92aIO::SPECTYPE ()
{
  //## begin OGIP_92aIO::SPECTYPE%39CBA1EB012B.get preserve=no
  return s_SPECTYPE;
  //## end OGIP_92aIO::SPECTYPE%39CBA1EB012B.get
}

inline const string& OGIP_92aIO::HDUCLAS1 ()
{
  //## begin OGIP_92aIO::HDUCLAS1%39CBA1FB03E7.get preserve=no
  return s_HDUCLAS1;
  //## end OGIP_92aIO::HDUCLAS1%39CBA1FB03E7.get
}

inline const string& OGIP_92aIO::RMFVERSN ()
{
  //## begin OGIP_92aIO::RMFVERSN%39D0D4580244.get preserve=no
  return s_RMFVERSN;
  //## end OGIP_92aIO::RMFVERSN%39D0D4580244.get
}

inline const string& OGIP_92aIO::ARFVERSN ()
{
  //## begin OGIP_92aIO::ARFVERSN%39D0D48302BB.get preserve=no
  return s_ARFVERSN;
  //## end OGIP_92aIO::ARFVERSN%39D0D48302BB.get
}

inline const string& OGIP_92aIO::OGIPVERS ()
{
  //## begin OGIP_92aIO::OGIPVERS%39D0D4A000A6.get preserve=no
  return s_OGIPVERS;
  //## end OGIP_92aIO::OGIPVERS%39D0D4A000A6.get
}

inline const string& OGIP_92aIO::RESPTYPE ()
{
  //## begin OGIP_92aIO::RESPTYPE%39D0D512011E.get preserve=no
  return s_RESPTYPE;
  //## end OGIP_92aIO::RESPTYPE%39D0D512011E.get
}

inline const string& OGIP_92aIO::SPECRESPTYPE ()
{
  //## begin OGIP_92aIO::SPECRESPTYPE%39D0D66500E4.get preserve=no
  return s_SPECRESPTYPE;
  //## end OGIP_92aIO::SPECRESPTYPE%39D0D66500E4.get
}

inline const string& OGIP_92aIO::HDUCLAS2 ()
{
  //## begin OGIP_92aIO::HDUCLAS2%39D0D68E030B.get preserve=no
  return s_HDUCLAS2;
  //## end OGIP_92aIO::HDUCLAS2%39D0D68E030B.get
}

inline const string& OGIP_92aIO::OGIPTYPE ()
{
  //## begin OGIP_92aIO::OGIPTYPE%39D0D98002E2.get preserve=no
  return s_OGIPTYPE;
  //## end OGIP_92aIO::OGIPTYPE%39D0D98002E2.get
}

inline const string& OGIP_92aIO::NUMKEY ()
{
  //## begin OGIP_92aIO::NUMKEY%39D0DF5D0397.get preserve=no
  return s_NUMKEY;
  //## end OGIP_92aIO::NUMKEY%39D0DF5D0397.get
}

inline const string& OGIP_92aIO::CHANNEL ()
{
  //## begin OGIP_92aIO::CHANNEL%39DCC2BC017B.get preserve=no
  return s_CHANNEL;
  //## end OGIP_92aIO::CHANNEL%39DCC2BC017B.get
}

inline const string& OGIP_92aIO::TELESCOPE ()
{
  //## begin OGIP_92aIO::TELESCOPE%39DCC3000342.get preserve=no
  return s_TELESCOPE;
  //## end OGIP_92aIO::TELESCOPE%39DCC3000342.get
}

inline const string& OGIP_92aIO::INSTRUMENT ()
{
  //## begin OGIP_92aIO::INSTRUMENT%39DCC31802A9.get preserve=no
  return s_INSTRUMENT;
  //## end OGIP_92aIO::INSTRUMENT%39DCC31802A9.get
}

inline const string& OGIP_92aIO::BACKFILE ()
{
  //## begin OGIP_92aIO::BACKFILE%39DCC35B0243.get preserve=no
  return s_BACKFILE;
  //## end OGIP_92aIO::BACKFILE%39DCC35B0243.get
}

inline const string& OGIP_92aIO::RESPFILE ()
{
  //## begin OGIP_92aIO::RESPFILE%39DCC37D0123.get preserve=no
  return s_RESPFILE;
  //## end OGIP_92aIO::RESPFILE%39DCC37D0123.get
}

inline const string& OGIP_92aIO::CORRFILE ()
{
  //## begin OGIP_92aIO::CORRFILE%39DCC380030B.get preserve=no
  return s_CORRFILE;
  //## end OGIP_92aIO::CORRFILE%39DCC380030B.get
}

inline const string& OGIP_92aIO::ANCRFILE ()
{
  //## begin OGIP_92aIO::ANCRFILE%39DCC3840082.get preserve=no
  return s_ANCRFILE;
  //## end OGIP_92aIO::ANCRFILE%39DCC3840082.get
}

inline const string& OGIP_92aIO::AREASCALE ()
{
  //## begin OGIP_92aIO::AREASCALE%39DCC3FA0279.get preserve=no
  return s_AREASCALE;
  //## end OGIP_92aIO::AREASCALE%39DCC3FA0279.get
}

inline const string& OGIP_92aIO::BACKSCALE ()
{
  //## begin OGIP_92aIO::BACKSCALE%39DCC3FF027D.get preserve=no
  return s_BACKSCALE;
  //## end OGIP_92aIO::BACKSCALE%39DCC3FF027D.get
}

inline const string& OGIP_92aIO::CORRSCALE ()
{
  //## begin OGIP_92aIO::CORRSCALE%39DCC40302B7.get preserve=no
  return s_CORRSCALE;
  //## end OGIP_92aIO::CORRSCALE%39DCC40302B7.get
}

inline const string& OGIP_92aIO::EXPOSURE ()
{
  //## begin OGIP_92aIO::EXPOSURE%39DCC4070133.get preserve=no
  return s_EXPOSURE;
  //## end OGIP_92aIO::EXPOSURE%39DCC4070133.get
}

inline const string& OGIP_92aIO::FILTER ()
{
  //## begin OGIP_92aIO::FILTER%39DCC40B015B.get preserve=no
  return s_FILTER;
  //## end OGIP_92aIO::FILTER%39DCC40B015B.get
}

inline const string& OGIP_92aIO::GROUPING ()
{
  //## begin OGIP_92aIO::GROUPING%39DCC4EB0196.get preserve=no
  return s_GROUPING;
  //## end OGIP_92aIO::GROUPING%39DCC4EB0196.get
}

inline const string& OGIP_92aIO::QUALITY ()
{
  //## begin OGIP_92aIO::QUALITY%39DCC4EF003B.get preserve=no
  return s_QUALITY;
  //## end OGIP_92aIO::QUALITY%39DCC4EF003B.get
}

inline const size_t& OGIP_92aIO::MAXFILTER ()
{
  //## begin OGIP_92aIO::MAXFILTER%39DCCF3F0191.get preserve=no
  return s_MAXFILTER;
  //## end OGIP_92aIO::MAXFILTER%39DCCF3F0191.get
}

inline const string& OGIP_92aIO::CHANNELTYPE ()
{
  //## begin OGIP_92aIO::CHANNELTYPE%39DCD8290218.get preserve=no
  return s_CHANNELTYPE;
  //## end OGIP_92aIO::CHANNELTYPE%39DCD8290218.get
}

inline const string& OGIP_92aIO::COUNTS ()
{
  //## begin OGIP_92aIO::COUNTS%39DCD8E7023A.get preserve=no
  return s_COUNTS;
  //## end OGIP_92aIO::COUNTS%39DCD8E7023A.get
}

inline const string& OGIP_92aIO::RATE ()
{
  //## begin OGIP_92aIO::RATE%39DCDA780352.get preserve=no
  return s_RATE;
  //## end OGIP_92aIO::RATE%39DCDA780352.get
}

inline const string& OGIP_92aIO::SYSTEMATIC ()
{
  //## begin OGIP_92aIO::SYSTEMATIC%39E362940011.get preserve=no
  return s_SYSTEMATIC;
  //## end OGIP_92aIO::SYSTEMATIC%39E362940011.get
}

inline const string& OGIP_92aIO::STATISTICAL ()
{
  //## begin OGIP_92aIO::STATISTICAL%39E3629A0358.get preserve=no
  return s_STATISTICAL;
  //## end OGIP_92aIO::STATISTICAL%39E3629A0358.get
}

inline const string& OGIP_92aIO::POISSERR ()
{
  //## begin OGIP_92aIO::POISSERR%39FDEA390117.get preserve=no
  return s_POISSERR;
  //## end OGIP_92aIO::POISSERR%39FDEA390117.get
}

inline const string& OGIP_92aIO::MINENERGY ()
{
  //## begin OGIP_92aIO::MINENERGY%3A002E4101C3.get preserve=no
  return s_MINENERGY;
  //## end OGIP_92aIO::MINENERGY%3A002E4101C3.get
}

inline const string& OGIP_92aIO::MAXENERGY ()
{
  //## begin OGIP_92aIO::MAXENERGY%3A002E62003F.get preserve=no
  return s_MAXENERGY;
  //## end OGIP_92aIO::MAXENERGY%3A002E62003F.get
}

inline const string& OGIP_92aIO::ENERGYLO ()
{
  //## begin OGIP_92aIO::ENERGYLO%3A002E7D0352.get preserve=no
  return s_ENERGYLO;
  //## end OGIP_92aIO::ENERGYLO%3A002E7D0352.get
}

inline const string& OGIP_92aIO::ENERGYHI ()
{
  //## begin OGIP_92aIO::ENERGYHI%3A002EA500AB.get preserve=no
  return s_ENERGYHI;
  //## end OGIP_92aIO::ENERGYHI%3A002EA500AB.get
}

inline const string& OGIP_92aIO::NGROUP ()
{
  //## begin OGIP_92aIO::NGROUP%3A002EC000DD.get preserve=no
  return s_NGROUP;
  //## end OGIP_92aIO::NGROUP%3A002EC000DD.get
}

inline const string& OGIP_92aIO::NCHANNEL ()
{
  //## begin OGIP_92aIO::NCHANNEL%3A002EE103CD.get preserve=no
  return s_NCHANNEL;
  //## end OGIP_92aIO::NCHANNEL%3A002EE103CD.get
}

inline const string& OGIP_92aIO::FCHANNEL ()
{
  //## begin OGIP_92aIO::FCHANNEL%3A002EFE0085.get preserve=no
  return s_FCHANNEL;
  //## end OGIP_92aIO::FCHANNEL%3A002EFE0085.get
}

inline const string& OGIP_92aIO::MATRIX ()
{
  //## begin OGIP_92aIO::MATRIX%3A002F1B0113.get preserve=no
  return s_MATRIX;
  //## end OGIP_92aIO::MATRIX%3A002F1B0113.get
}

inline const string& OGIP_92aIO::DETNAM ()
{
  //## begin OGIP_92aIO::DETNAM%3A003AAA03B0.get preserve=no
  return s_DETNAM;
  //## end OGIP_92aIO::DETNAM%3A003AAA03B0.get
}

inline const string& OGIP_92aIO::DETCHANS ()
{
  //## begin OGIP_92aIO::DETCHANS%3A003ACE0233.get preserve=no
  return s_DETCHANS;
  //## end OGIP_92aIO::DETCHANS%3A003ACE0233.get
}

inline const string& OGIP_92aIO::RSPVERSN ()
{
  //## begin OGIP_92aIO::RSPVERSN%3A003AD10011.get preserve=no
  return s_RSPVERSN;
  //## end OGIP_92aIO::RSPVERSN%3A003AD10011.get
}

inline const string& OGIP_92aIO::EBOUNDS ()
{
  //## begin OGIP_92aIO::EBOUNDS%3A40D2AE01E3.get preserve=no
  return s_EBOUNDS;
  //## end OGIP_92aIO::EBOUNDS%3A40D2AE01E3.get
}

inline const string& OGIP_92aIO::RSPMATRIXTYPE ()
{
  //## begin OGIP_92aIO::RSPMATRIXTYPE%3A6DF2D203CA.get preserve=no
  return s_RSPMATRIXTYPE;
  //## end OGIP_92aIO::RSPMATRIXTYPE%3A6DF2D203CA.get
}

inline const string& OGIP_92aIO::HDUCLAS3 ()
{
  //## begin OGIP_92aIO::HDUCLAS3%3FD8899E036B.get preserve=no
  return s_HDUCLAS3;
  //## end OGIP_92aIO::HDUCLAS3%3FD8899E036B.get
}

inline const string& OGIP_92aIO::GSLOP_MIN ()
{
  //## begin OGIP_92aIO::GSLOP_MIN%4A3A58C6019E.get preserve=no
  return s_GSLOP_MIN;
  //## end OGIP_92aIO::GSLOP_MIN%4A3A58C6019E.get
}

inline const string& OGIP_92aIO::GSLOP_MAX ()
{
  //## begin OGIP_92aIO::GSLOP_MAX%4A3A58C9013C.get preserve=no
  return s_GSLOP_MAX;
  //## end OGIP_92aIO::GSLOP_MAX%4A3A58C9013C.get
}

inline const string& OGIP_92aIO::GOFFS_MIN ()
{
  //## begin OGIP_92aIO::GOFFS_MIN%4A3A58CC002B.get preserve=no
  return s_GOFFS_MIN;
  //## end OGIP_92aIO::GOFFS_MIN%4A3A58CC002B.get
}

inline const string& OGIP_92aIO::GOFFS_MAX ()
{
  //## begin OGIP_92aIO::GOFFS_MAX%4A3A58CE030F.get preserve=no
  return s_GOFFS_MAX;
  //## end OGIP_92aIO::GOFFS_MAX%4A3A58CE030F.get
}

inline void OGIP_92aIO::net (bool value)
{
  //## begin OGIP_92aIO::net%3FD8904701AA.set preserve=no
  m_net = value;
  //## end OGIP_92aIO::net%3FD8904701AA.set
}

inline bool OGIP_92aIO::netIsSet () const
{
  //## begin OGIP_92aIO::netIsSet%3FD8983A00D9.get preserve=no
  return m_netIsSet;
  //## end OGIP_92aIO::netIsSet%3FD8983A00D9.get
}

inline void OGIP_92aIO::netIsSet (bool value)
{
  //## begin OGIP_92aIO::netIsSet%3FD8983A00D9.set preserve=no
  m_netIsSet = value;
  //## end OGIP_92aIO::netIsSet%3FD8983A00D9.set
}

inline void OGIP_92aIO::qualityStorage (OGIP_92aIO::StorageType value)
{
  //## begin OGIP_92aIO::qualityStorage%402407EA011B.set preserve=no
  m_qualityStorage = value;
  //## end OGIP_92aIO::qualityStorage%402407EA011B.set
}

inline void OGIP_92aIO::groupingStorage (OGIP_92aIO::StorageType value)
{
  //## begin OGIP_92aIO::groupingStorage%4024082E019E.set preserve=no
  m_groupingStorage = value;
  //## end OGIP_92aIO::groupingStorage%4024082E019E.set
}

inline int OGIP_92aIO::extVers () const
{
  //## begin OGIP_92aIO::extVers%48A498300276.get preserve=no
  return m_extVers;
  //## end OGIP_92aIO::extVers%48A498300276.get
}

inline void OGIP_92aIO::extVers (int value)
{
  //## begin OGIP_92aIO::extVers%48A498300276.set preserve=no
  m_extVers = value;
  //## end OGIP_92aIO::extVers%48A498300276.set
}

//## Get and Set Operations for Associations (inline)

inline std::vector<std::string>& OGIP_92aIO::SpectrumKeys ()
{
  //## begin OGIP_92aIO::SpectrumKeys%39DCD1FA01FE.get preserve=no
  return s_SpectrumKeys;
  //## end OGIP_92aIO::SpectrumKeys%39DCD1FA01FE.get
}

inline void OGIP_92aIO::SpectrumKeys (const std::vector<std::string>& value)
{
  //## begin OGIP_92aIO::SpectrumKeys%39DCD1FA01FE.set preserve=no
  s_SpectrumKeys = value;
  //## end OGIP_92aIO::SpectrumKeys%39DCD1FA01FE.set
}

inline const std::vector<std::string>& OGIP_92aIO::ResponseKeys ()
{
  //## begin OGIP_92aIO::ResponseKeys%39E5D8CC03D5.get preserve=no
  return s_ResponseKeys;
  //## end OGIP_92aIO::ResponseKeys%39E5D8CC03D5.get
}

inline const std::vector<CCfits::FITS*>& OGIP_92aIO::getDataSource () const
{
  //## begin OGIP_92aIO::getDataSource%3AAD00DC0080.get preserve=no
  return m_dataSource;
  //## end OGIP_92aIO::getDataSource%3AAD00DC0080.get
}

inline void OGIP_92aIO::setDataSource (const std::vector<CCfits::FITS*>& value)
{
  //## begin OGIP_92aIO::setDataSource%3AAD00DC0080.set preserve=no
  m_dataSource = value;
  //## end OGIP_92aIO::setDataSource%3AAD00DC0080.set
}

inline const std::vector<std::string>& OGIP_92aIO::AuxResponseKeys ()
{
  //## begin OGIP_92aIO::AuxResponseKeys%3AAD0ADE0259.get preserve=no
  return s_AuxResponseKeys;
  //## end OGIP_92aIO::AuxResponseKeys%3AAD0ADE0259.get
}

inline void OGIP_92aIO::AuxResponseKeys (const std::vector<std::string>& value)
{
  //## begin OGIP_92aIO::AuxResponseKeys%3AAD0ADE0259.set preserve=no
  s_AuxResponseKeys = value;
  //## end OGIP_92aIO::AuxResponseKeys%3AAD0ADE0259.set
}

inline const std::vector<std::string>& OGIP_92aIO::typeIColNames ()
{
  //## begin OGIP_92aIO::typeIColNames%3EF372E300F6.get preserve=no
  return s_typeIColNames;
  //## end OGIP_92aIO::typeIColNames%3EF372E300F6.get
}

inline const std::vector<std::string>& OGIP_92aIO::typeIColForms ()
{
  //## begin OGIP_92aIO::typeIColForms%3EF374B50243.get preserve=no
  return s_typeIColForms;
  //## end OGIP_92aIO::typeIColForms%3EF374B50243.get
}

inline const std::vector<std::string>& OGIP_92aIO::typeIColUnits ()
{
  //## begin OGIP_92aIO::typeIColUnits%3EF3754F01A2.get preserve=no
  return s_typeIColUnits;
  //## end OGIP_92aIO::typeIColUnits%3EF3754F01A2.get
}

//## begin module%39A3E1C30247.epilog preserve=yes
//## end module%39A3E1C30247.epilog


#endif
